import torch 
torch.manual_seed(42)

dtype = torch.float64 
device = 'cuda:0'
N = 100
chi = 20

A = torch.randn(N, N, dtype=dtype, device=device)
U, S, V = torch.svd(A)
P = U[:, :chi]

projected_trace = torch.trace(A@A.t() @ P @P.t())
target = ((S[:chi])**2).sum()

print (projected_trace.item(), target.item())

w = torch.randn(N, chi, dtype=dtype, device=device)
for step in range(20):
    E = w.t()@A@A.t()
    U, S, V = torch.svd(E)
    w = V@U.t()

    loss = torch.trace(A@A.t() @ w @ w.t())
    print (step, ((loss-target)/target).item(), ((projected_trace-target)/target).item())

